﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Modul_A_WPF
{
		/// <summary>
		/// Interaktionslogik für MainWindow.xaml
		/// </summary>
		public partial class MainWindow : Window
		{
				private SerialPort serialPort = new SerialPort();
				private bool[] digitalOut = new bool[8];
				private DispatcherTimer timer;

				public MainWindow()
				{
						InitializeComponent();
						timer = new DispatcherTimer();
						timer.Interval = TimeSpan.FromMilliseconds(100);
						timer.Tick += Timer_Tick;
				}

				private void WindowModulA_Loaded(object sender, RoutedEventArgs e)
				{
						buttonVerbinden.IsEnabled = false;
						buttonTrennen.IsEnabled = false;
						buttonDA0.IsEnabled = false;
						buttonDA1.IsEnabled = false;
						buttonDA2.IsEnabled = false;
						buttonDA3.IsEnabled = false;
						buttonDA4.IsEnabled = false;
						buttonDA5.IsEnabled = false;
						buttonDA6.IsEnabled = false;
						buttonDA7.IsEnabled = false;
						groupBoxKanal.IsEnabled = false;

						string[] ports = SerialPort.GetPortNames();
						Array.Sort(ports);
						if (ports.Length > 0)
						{
								foreach (string Port in ports)
										comboBoxPort.Items.Add(Port);
								comboBoxPort.SelectedIndex = 0;
								buttonVerbinden.IsEnabled = true;
						}
						for (int i = 0; i < 8; i++)
								digitalOut[i] = false;
				}

				private void WindowModulA_Closing(object sender, System.ComponentModel.CancelEventArgs e)
				{
						if (serialPort.IsOpen)
						{
								serialPort.Write("LLLLLLLL");
								serialPort.Close();
						}
				}

				private void ButtonVerbinden_Click(object sender, RoutedEventArgs e)
				{
						try
						{
								buttonVerbinden.IsEnabled = false;
								buttonTrennen.IsEnabled = true;
								buttonDA0.IsEnabled = true;
								buttonDA1.IsEnabled = true;
								buttonDA2.IsEnabled = true;
								buttonDA3.IsEnabled = true;
								buttonDA4.IsEnabled = true;
								buttonDA5.IsEnabled = true;
								buttonDA6.IsEnabled = true;
								buttonDA7.IsEnabled = true;
								groupBoxKanal.IsEnabled = true;

								serialPort.PortName = comboBoxPort.Text;
								serialPort.BaudRate = 9600;
								serialPort.DtrEnable = false;
								serialPort.RtsEnable = true;
								serialPort.Open();
								timer.Start();
						}
						catch
						{
								buttonVerbinden.IsEnabled = true;
								buttonTrennen.IsEnabled = false;
								buttonDA0.IsEnabled = false;
								buttonDA1.IsEnabled = false;
								buttonDA2.IsEnabled = false;
								buttonDA3.IsEnabled = false;
								buttonDA4.IsEnabled = false;
								buttonDA5.IsEnabled = false;
								buttonDA6.IsEnabled = false;
								buttonDA7.IsEnabled = false;
								groupBoxKanal.IsEnabled = false;
								MessageBox.Show("Die Schnittstelle konnte nicht geöffnet werden!");
						}
				}

				private void ButtonTrennen_Click(object sender, RoutedEventArgs e)
				{
						buttonVerbinden.IsEnabled = true;
						buttonTrennen.IsEnabled = false;
						buttonDA0.IsEnabled = false;
						buttonDA1.IsEnabled = false;
						buttonDA2.IsEnabled = false;
						buttonDA3.IsEnabled = false;
						buttonDA4.IsEnabled = false;
						buttonDA5.IsEnabled = false;
						buttonDA6.IsEnabled = false;
						buttonDA7.IsEnabled = false;
						groupBoxKanal.IsEnabled = false;
						timer.Stop();
						serialPort.Write("LLLLLLLL");
						serialPort.Close();
						textBoxAEWert.Text = "0000";
						textBoxAESpannung.Text = "0,00 V";
						for (int i = 0; i < 8; i++)
								digitalOut[i] = false;
						textBoxDA0.Text = "L";
						textBoxDA1.Text = "L";
						textBoxDA2.Text = "L";
						textBoxDA3.Text = "L";
						textBoxDA4.Text = "L";
						textBoxDA5.Text = "L";
						textBoxDA6.Text = "L";
						textBoxDA7.Text = "L";
				}

				private void ButtonDA0_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[0] = !digitalOut[0];
						if (digitalOut[0])
								textBoxDA0.Text = "H";
						else
								textBoxDA0.Text = "L";
				}

				private void ButtonDA1_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[1] = !digitalOut[1];
						if (digitalOut[1])
								textBoxDA1.Text = "H";
						else
								textBoxDA1.Text = "L";
				}

				private void ButtonDA2_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[2] = !digitalOut[2];
						if (digitalOut[2])
								textBoxDA2.Text = "H";
						else
								textBoxDA2.Text = "L";
				}

				private void ButtonDA3_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[3] = !digitalOut[3];
						if (digitalOut[3])
								textBoxDA3.Text = "H";
						else
								textBoxDA3.Text = "L";
				}

				private void ButtonDA4_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[4] = !digitalOut[4];
						if (digitalOut[4])
								textBoxDA4.Text = "H";
						else
								textBoxDA4.Text = "L";
				}

				private void ButtonDA5_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[5] = !digitalOut[5];
						if (digitalOut[5])
								textBoxDA5.Text = "H";
						else
								textBoxDA5.Text = "L";
				}

				private void ButtonDA6_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[6] = !digitalOut[6];
						if (digitalOut[6])
								textBoxDA6.Text = "H";
						else
								textBoxDA6.Text = "L";
				}

				private void ButtonDA7_Click(object sender, RoutedEventArgs e)
				{
						digitalOut[7] = !digitalOut[7];
						if (digitalOut[7])
								textBoxDA7.Text = "H";
						else
								textBoxDA7.Text = "L";
				}

				private void Timer_Tick(object sender, EventArgs e)
				{
						int count = serialPort.BytesToRead;
						char[] cOut = new char[9];
						char[] cIn = new char[count];
						string strWert;
						int wert;
						double spannung;

						textBoxAEWert.Text = "";
						strWert = "";
						if (serialPort.IsOpen)
						{
								for (int i = 0; i < 8; i++)
								{
										if (digitalOut[i])
												cOut[i] = 'H';
										else
												cOut[i] = 'L';
								}
								if (radioButtonA0.IsChecked == true)
										cOut[8] = '0';
								if (radioButtonA1.IsChecked == true)
										cOut[8] = '1';
								if (radioButtonA2.IsChecked == true)
										cOut[8] = '2';
								if (radioButtonA3.IsChecked == true)
										cOut[8] = '3';
								serialPort.Write(cOut, 0, 9);

								if (count > 0)
										serialPort.Read(cIn, 0, count);
								if (cIn[0] == 'H')
										textBoxDE0.Text = "H";
								else
										textBoxDE0.Text = "L";
								if (cIn[1] == 'H')
										textBoxDE1.Text = "H";
								else
										textBoxDE1.Text = "L";
								if (cIn[2] == 'H')
										textBoxDE2.Text = "H";
								else
										textBoxDE2.Text = "L";
								if (cIn[3] == 'H')
										textBoxDE3.Text = "H";
								else
										textBoxDE3.Text = "L";

								for (int i = 4; i < 8; i++)
										strWert = strWert + cIn[i].ToString();
								try
								{
										wert = Convert.ToInt32(strWert);
										spannung = (double)wert * 5 / 1023;
										textBoxAEWert.Text = strWert;
										textBoxAESpannung.Text = string.Format("{0:F} V", spannung);
								}
								catch
								{
										textBoxAEWert.Text = "0000";
								}
						}
				}
		}
}
